// <auto-generated>
//  automatically generated by the FlatBuffers compiler, do not modify
// </auto-generated>

namespace Veneris.Communications
{

using global::System;
using global::System.Collections.Generic;
using global::FlatBuffers;

public struct DynamicMesh : IFlatbufferObject
{
  private Table __p;
  public ByteBuffer ByteBuffer { get { return __p.bb; } }
  public static void ValidateVersion() { FlatBufferConstants.FLATBUFFERS_2_0_0(); }
  public static DynamicMesh GetRootAsDynamicMesh(ByteBuffer _bb) { return GetRootAsDynamicMesh(_bb, new DynamicMesh()); }
  public static DynamicMesh GetRootAsDynamicMesh(ByteBuffer _bb, DynamicMesh obj) { return (obj.__assign(_bb.GetInt(_bb.Position) + _bb.Position, _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __p = new Table(_i, _bb); }
  public DynamicMesh __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public int Id { get { int o = __p.__offset(4); return o != 0 ? __p.bb.GetInt(o + __p.bb_pos) : (int)0; } }
  public Veneris.Communications.Vec3? Vertices(int j) { int o = __p.__offset(6); return o != 0 ? (Veneris.Communications.Vec3?)(new Veneris.Communications.Vec3()).__assign(__p.__vector(o) + j * 12, __p.bb) : null; }
  public int VerticesLength { get { int o = __p.__offset(6); return o != 0 ? __p.__vector_len(o) : 0; } }
  public int Indexes(int j) { int o = __p.__offset(8); return o != 0 ? __p.bb.GetInt(__p.__vector(o) + j * 4) : (int)0; }
  public int IndexesLength { get { int o = __p.__offset(8); return o != 0 ? __p.__vector_len(o) : 0; } }
#if ENABLE_SPAN_T
  public Span<int> GetIndexesBytes() { return __p.__vector_as_span<int>(8, 4); }
#else
  public ArraySegment<byte>? GetIndexesBytes() { return __p.__vector_as_arraysegment(8); }
#endif
  public int[] GetIndexesArray() { return __p.__vector_as_array<int>(8); }
  public Veneris.Communications.MaterialEMP? Material { get { int o = __p.__offset(10); return o != 0 ? (Veneris.Communications.MaterialEMP?)(new Veneris.Communications.MaterialEMP()).__assign(o + __p.bb_pos, __p.bb) : null; } }

  public static void StartDynamicMesh(FlatBufferBuilder builder) { builder.StartTable(4); }
  public static void AddId(FlatBufferBuilder builder, int id) { builder.AddInt(0, id, 0); }
  public static void AddVertices(FlatBufferBuilder builder, VectorOffset verticesOffset) { builder.AddOffset(1, verticesOffset.Value, 0); }
  public static void StartVerticesVector(FlatBufferBuilder builder, int numElems) { builder.StartVector(12, numElems, 4); }
  public static void AddIndexes(FlatBufferBuilder builder, VectorOffset indexesOffset) { builder.AddOffset(2, indexesOffset.Value, 0); }
  public static VectorOffset CreateIndexesVector(FlatBufferBuilder builder, int[] data) { builder.StartVector(4, data.Length, 4); for (int i = data.Length - 1; i >= 0; i--) builder.AddInt(data[i]); return builder.EndVector(); }
  public static VectorOffset CreateIndexesVectorBlock(FlatBufferBuilder builder, int[] data) { builder.StartVector(4, data.Length, 4); builder.Add(data); return builder.EndVector(); }
  public static void StartIndexesVector(FlatBufferBuilder builder, int numElems) { builder.StartVector(4, numElems, 4); }
  public static void AddMaterial(FlatBufferBuilder builder, Offset<Veneris.Communications.MaterialEMP> materialOffset) { builder.AddStruct(3, materialOffset.Value, 0); }
  public static Offset<Veneris.Communications.DynamicMesh> EndDynamicMesh(FlatBufferBuilder builder) {
    int o = builder.EndTable();
    return new Offset<Veneris.Communications.DynamicMesh>(o);
  }
  public static void FinishDynamicMeshBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.DynamicMesh> offset) { builder.Finish(offset.Value); }
  public static void FinishSizePrefixedDynamicMeshBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.DynamicMesh> offset) { builder.FinishSizePrefixed(offset.Value); }
};


}
